[CentOS-virt] xen+drbd Question

Ross S. W. Walker RWalker at medallion.com
Wed Aug 27 15:01:50 UTC 2008

Jerry Amundson wrote:
> yes. i replied to myself.

Talking to yourself is the first sign of insanity!

The second being, disagreeing with the first.

> On Tue, Aug 26, 2008 at 10:56 PM, Jerry Amundson <jamundso at gmail.com> wrote:
> > On Tue, Aug 26, 2008 at 11:25 AM, Ross S. W. Walker <RWalker at medallion.com> wrote:
> >> Alexandre Biancalana wrote:
> >>> On 8/26/08, Ross S. W. Walker <RWalker at medallion.com> wrote:
> >>> >  If you upgrade to xen.org release of Xen then you can use the
> >>> >  block-drbd script to specify by drbd resource name instead of
> >>> >  device, but that's just fluff in stuff, and doesn't have
> >>> >  anything to do with the ability to live migrate which is all
> >>> >  handled by the allow-two-primaries option.
> >
> > True. In my case : CentOS 5.3, incl. kernel-xen and heartbeat, Xen.org
> > 3.x, DRBD 8.2.
> > It works, but has no cookie-cutter howto.
> >
> >>> Are you saying that we can only use block-drbd script with Xen 3.2 ?
> >
> > It's really not so much the Xen version, but the distro.
> more so, within the distro, the bootstrap method used for the domU

More specifically 'pygrub' itself as mentioned below.

> >> It might work with the Xen 3.1 libraries too, but that's also
> >> irrelevant as CentOS/RHEL has decided to use the Xen 3.0.3
> >> libraries (though they are using the Xen 3.1 hypervisor, go
> >> figure!).
> >
> > How did you determine they are different versions?
> oh, maybe the thread I just noticed in xen-users?
> http://lists.xensource.com/archives/html/xen-users/2008-08/msg00791.html
> where Pasi says,
> -> To be more clear about it, RHEL 5.2 version of Xen _hypervisor_ is 3.1.2 +
> -> patches.
> -> RHEL 5.2 kernel-xen is based on older Xen (3.0.3 iirc) kernel code.

Actually I found the version information through a 'xm info' which
shows it's running 3.1, but the libraries and supporting apps are
all 3.0.3.

xen_major              : 3
xen_minor              : 1
xen_extra              : .2-92.1.10.el5
xen_caps               : xen-3.0-x86_32p hvm-3.0-x86_32 hvm-3.0-x86_32p

> >> Linbit wrote the block-drbd script for Xen 3.1 (maybe 3.2) and
> >> up, but definitely not pre-3.1.
> >>
> >> For the definitive answer though I recommend posting on
> >> drbd-user. Someone there might even have a work-around to
> >> get it to work on earlier Xen libraries...
> >
> > http://lists.linbit.com/pipermail/drbd-user/2008-August/010077.html
> >

Ah so the culprit is pygrub, add that tidbit to my knowledge base.

So if you define the kernel and ramdisk from external sources
then the block script should work, but using pygrub, it only
recognizes standard block devices.

I suppose this will also affect the block-iscsi script out there

It would be nice if someone could patch pygrub to look for
handler scripts for any device NOT file, tap, phy and to use
them to bootload as it's better IMHO to manage the domU's
kernel and ramdisk from within the domU.


This e-mail, and any attachments thereto, is intended only for use by
the addressee(s) named herein and may contain legally privileged
and/or confidential information. If you are not the intended recipient
of this e-mail, you are hereby notified that any dissemination,
distribution or copying of this e-mail, and any attachments thereto,
is strictly prohibited. If you have received this e-mail in error,
please immediately notify the sender and permanently delete the
original and any copy or printout thereof.

More information about the CentOS-virt mailing list